{{
**********************************************
* PassingObjects test program (spin stamp)   *
* @version 1.3 Jan 13, 2008                  *
* @author Peter Verkaik (verkaik6@zonnet.nl) *
**********************************************
}}


CON
  
  'clock settings for spin stamp
  _clkmode = xtal1+pll8x
  _xinfreq = 10_000_000
  
  debugPort = 2 '0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN
  
  '//Spin stamp debug pin assignments
  stampSOUT = 16 'serial out (pin 1 of spin stamp)
  stampSIN  = 17 'serial in  (pin 2 of spin stamp)
  stampATN  = 18 'digital in (pin 3 of spin stamp, when activated, do reboot)

  '//Propeller system pin assignments
  propSCL = 28 'external eeprom SCL
  propSDA = 29 'external eeprom SDA
  propTX  = 30 'programming output
  propRX  = 31 'programming input


CON
  TotalObjects = 4     'number of objects under OBJ

  
OBJ
 debug: "MultiCogSerialDebug"   'index=0
 obj2:  "obj2"                  'index=1 
 obj1:  "obj1"                  'index=2
 po:    "PassingObjects"        'index=3


VAR
  long firstVariable       'you can store any value in here. we just need the address
  long handle
  long atnStack[10]        'stack for monitoring ATN pin
  byte debugSemID          'lock to be used by debug
  
  
DAT
  endOfObjects long 0      'you can store any value in here. we just need the address


PUB main
  'get lock for debug
  debugSemID := locknew
  'start debug
  case debugPort
    1: debug.start(propRX,propTX,0,9600,debugSemID)
    2: debug.start(stampSIN,stampSOUT,0,9600,debugSemID)
  waitcnt(clkfreq + cnt) 'wait 1 second

  'send welcome message
  debug.cprintf(string("PassingObjects test program\r"),0,false)
  'monitor ATN pin (optional)
'  if debugPort == 2
'    cognew(atnReset,@atnStack)

  obj1.init(string("ABCD"))   'this sets up text in obj1 and prints "ABCD"
  obj2.init                   'this sets up text in d and prints "PQRS"
  handle := po.getObjectHandle(2,1,TotalObjects,@endOfObjects,@firstVariable) 'get handle for obj1 to call from obj2 (see OBJ for indexes)
  obj2.run(handle)            'this prints the text array from d, but because d gets redirected it prints "ABCD"
  obj2.run(0)                 'and it prints "PQRS" again
  repeat

  
PUB atnReset
  repeat 'loop endlessly
    if (INA[stampATN] == 1)
      reboot

 